<script setup lang="ts">
import { reactive } from 'vue'
import ListWarning from '@/components/ListWarning.vue'
import { useAppStore } from '@/stores/app'

const app = useAppStore()

const state = reactive({
  formSciper: '',
  formEmail: '',
  loading: false,
  warningEmail: false,
  warningList: false,
  success: false
})

function submit(ignoreEmailWarning: boolean) {
  if (state.loading || state.formSciper.length !== 6 || state.formEmail.length === 0) {
    return
  }
  state.loading = true
  app
    .emailLoginRequest(state.formEmail, state.formSciper, ignoreEmailWarning)
    .then((res) => {
      if (res != null) {
        state.warningEmail = res.warning_email
        state.warningList = res.warning_list
        if (!state.warningEmail && !state.warningList) {
          state.success = true
        }
      }
    })
    .finally(() => {
      state.loading = false
    })
}
</script>

<template>
  <main id="main" class="flex justify-center items-center">
    <div class="relative p-4 w-full max-w-2xl h-full md:h-auto">
      <AppCard :title="$t('emailLogin.pageTitle')" :description="$t('emailLogin.pageDescription')">
        <div v-if="state.success" class="relative p-4 sm:p-5 text-center">
          <div
            class="mt-3 w-12 h-12 rounded-full bg-green-100 dark:bg-green-900 p-2 flex items-center justify-center mx-auto mb-3.5"
          >
            <svg
              aria-hidden="true"
              class="w-8 h-8 text-green-500 dark:text-green-400"
              fill="currentColor"
              viewBox="0 0 20 20"
              xmlns="http://www.w3.org/2000/svg"
            >
              <path
                fill-rule="evenodd"
                d="M16.707 5.293a1 1 0 010 1.414l-8 8a1 1 0 01-1.414 0l-4-4a1 1 0 011.414-1.414L8 12.586l7.293-7.293a1 1 0 011.414 0z"
                clip-rule="evenodd"
              ></path>
            </svg>
          </div>
          <p class="mb-4 text-lg font-semibold text-gray-900 dark:text-white">
            {{ $t('emailLogin.emailSent') }}
          </p>
        </div>

        <div v-else>
          <ListWarning
            v-if="state.warningList"
            auth="email"
            :sciper="state.formSciper"
            :email="state.formEmail"
          />

          <!-- Email Warning -->
          <div
            v-if="state.warningEmail"
            class="p-4 mb-4 text-yellow-800 border border-yellow-300 rounded-lg bg-yellow-50 dark:bg-gray-800 dark:text-yellow-400 dark:border-yellow-800"
            role="alert"
          >
            <div class="flex items-center">
              <svg
                class="flex-shrink-0 w-4 h-4 me-2"
                aria-hidden="true"
                xmlns="http://www.w3.org/2000/svg"
                fill="currentColor"
                viewBox="0 0 20 20"
              >
                <path
                  d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"
                />
              </svg>
              <span class="sr-only">Info</span>
              <h3 class="text-lg font-medium">{{ $t('emailLogin.emailWarning') }}</h3>
            </div>
            <div class="mt-2 mb-4 text-sm">
              <p class="whitespace-pre-line">{{ $t('emailLogin.emailWarningDescription') }}</p>
            </div>
            <div class="flex flex-row-reverse">
              <button
                @click="() => submit(true)"
                type="button"
                class="text-white bg-yellow-800 hover:bg-yellow-900 focus:ring-4 focus:outline-none focus:ring-yellow-300 font-medium rounded-lg text-xs px-3 py-1.5 me-2 text-center inline-flex items-center dark:bg-yellow-600 dark:hover:bg-yellow-700 dark:focus:ring-yellow-800"
              >
                <svg
                  class="me-2 w-4 h-4 text-gray-800 dark:text-white"
                  aria-hidden="true"
                  xmlns="http://www.w3.org/2000/svg"
                  width="24"
                  height="24"
                  fill="none"
                  viewBox="0 0 24 24"
                >
                  <path
                    stroke="currentColor"
                    stroke-linecap="round"
                    stroke-linejoin="round"
                    stroke-width="2"
                    d="M5 11.917 9.724 16.5 19 7.5"
                  />
                </svg>

                {{ $t('emailLogin.confirmEmailWarning') }}
              </button>
            </div>
          </div>

          <!-- Form -->
          <form class="mt-5" @submit.prevent>
            <div class="mb-6 space-y-3">
              <div class="">
                <label
                  for="email"
                  class="mb-2 block text-sm font-medium text-gray-900 dark:text-white"
                >
                  {{ $t('emailLogin.emailLabel') }}
                </label>
                <input
                  v-model="state.formEmail"
                  type="email"
                  id="email"
                  class="block w-full rounded-lg border border-gray-300 bg-gray-50 p-2.5 text-sm text-gray-900 focus:border-primary-500 focus:ring-primary-500 dark:border-gray-600 dark:bg-gray-700 dark:text-white dark:placeholder:text-gray-400 dark:focus:border-primary-500 dark:focus:ring-primary-500"
                  placeholder="m.vetterli@example.com"
                  required
                />
                <p class="mt-2 text-sm text-gray-500 dark:text-gray-400">
                  {{ $t('emailLogin.emailHint') }}
                </p>
              </div>

              <div class="">
                <label
                  for="sciper"
                  class="mb-2 block text-sm font-medium text-gray-900 dark:text-white"
                >
                  {{ $t('emailLogin.sciperLabel') }}
                </label>
                <input
                  v-model="state.formSciper"
                  type="text"
                  id="sciper"
                  class="block w-full rounded-lg border border-gray-300 bg-gray-50 p-2.5 text-sm text-gray-900 focus:border-primary-500 focus:ring-primary-500 dark:border-gray-600 dark:bg-gray-700 dark:text-white dark:placeholder:text-gray-400 dark:focus:border-primary-500 dark:focus:ring-primary-500"
                  placeholder="123456"
                  required
                />
              </div>
            </div>

            <div class="flex justify-between">
              <RouterLink to="/home">
                <AppButton variant="text-faint">
                  {{ $t('ui.back') }}
                </AppButton>
              </RouterLink>
              <AppButton @click="() => submit(false)" variant="outlined" :loading="state.loading"
                >{{ $t('ui.next') }}
              </AppButton>
            </div>
          </form>
        </div>
      </AppCard>
    </div>
  </main>
</template>
